/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * FXClear.cpp: 'effect' to clear the buffer.
 * leto/calodox, 28.12.2000
 */

#include "opengl.h"
#include "fxclear.h"

FXClear::FXClear() {
	str = new char[300];
	str[0]=0;
	col[0] = 0;
	col[1] = 0;
	col[2] = 0;
	col[3] = 1;
	active = true;
		
}

FXGeneric *FXClear::create() {
	return new FXClear();
}

char *FXClear::getName() {
		return "Clear";
}

void FXClear::registerOptions() {
	/*
	registerFloatOpt("rouge", 0, col, 0, 1);
	registerFloatOpt("vert", 0, col + 1, 0, 1);
	registerFloatOpt("bleu", 0, col + 2, 0, 1);
	*/
	registerColorOpt("Background color", 0, col);
	registerBoolOpt("active", 0, &active);
}

int FXClear::init() {
		return 0; 
}

int FXClear::render() {
		glClearColor(col[0], col[1], col[2], 1.0f);

		if (active) {
			glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
		}

		return 0;
}

void FXClear::finish() {
}

