/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include "fxdebug.h"

FXDebug::FXDebug() {
	buff=0;
	f = f2 = 0;
	i = 0;
	b = true;
	s[0]=0;
	printf("FXDebug created.\n");
}

FXGeneric *FXDebug::create() {
	return new FXDebug();
}

void FXDebug::registerOptions() {
	registerFloatOpt("float", 0, &f);
	registerIntOpt("int", 0, &i);
	registerBoolOpt("bool", 0, &b);
	registerFloatOpt("f2", 0, &f2);
	registerStringOpt("string", 0, s, sizeof(s));
	register3DPosOpt("position", 0, pos);
	register3DRotOpt("rotation", 0, rot);
	registerDrawBufferOpt("buffer", 0, &buff);
	registerScreenPosOpt("2d pos", 0, screenPos);
	registerRectangleOpt("rectangle", 0, rect);
}

int FXDebug::init() {
	printf("FXDebug initialized\n");
	return 1;
}

int FXDebug::render() {
	printf("FXDebug: %f, %d, %s, \"%s\", 2d pos: (%f, %f).         \r",
		f,i, b ? "true" : "false", s,
		screenPos[0], screenPos[1]);
	fflush(stdout);
	return 1;
}

void FXDebug::finish() {
	printf("FXDebug: finished.\n");
}
