/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * Time & effects control dialog for demoniac
 * leto@calodox.org, 9.2001
 */

#ifndef _CTRLDLG_H_
#define _CTRLDLG_H_

#include "fxinstance.h"
#include "dlg.h"

class ControlDlg : public Dlg {
private:
	// time contollers
	GtkWidget *timeSpinner;
	GtkWidget *playStopButtonLabel;

	// Column list for instances
	GtkWidget *instCList;

	friend gint cbUpButton(GtkWidget *widget, gpointer data);
	friend gint cbDownButton(GtkWidget *widget, gpointer data);

public:
	ControlDlg();
	virtual ~ControlDlg();

	virtual void build();
	virtual const char *getName();

	void addFXInstance(FXInstance *fxi);
	void renameInstance(unsigned int i);
	void removeListItem(unsigned int nb);
	void setPlayStopLabel(const char *name);
};

// callback prototypes

gint cbFXChoose(GtkWidget *widget, gpointer data);
gint cbFXInstanceCList(GtkWidget *widget, gint row, gint col,  GdkEvent *event, gpointer data);
gint cbConfigureButton(GtkWidget *widget, gpointer data);
void cbCListRowMove(GtkCList *clist, gint a, gint b, gpointer data);
gint cbUpButton(GtkWidget *widget, gpointer data);
gint cbDownButton(GtkWidget *widget, gpointer data);
gint cbRemoveInstance(GtkWidget *widget, gpointer data);

#endif
