/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * DlgOpt.h: options dialog box for GLDemoNiac.
 * Leto/calodox, 12.2000
 */

#ifndef _DLGOPT_H_
#define _DLGOPT_H_

#include <gtk/gtk.h>
#include <fx.h>
#include "dlg.h"

class FXInstance;

class DlgOpt : public Dlg {
private:
	FXInstance *fxi;

	GtkWidget *vbox;	// Gtk vbox for initVBox and rtVBox
	GtkWidget *initVBox;	// Gtk vbox for init options
	GtkWidget *rtVBox;	// Gtk vbox for run time options

	// time spinners to init/start/stop the fx
	GtkSpinButton *initSpin, *startSpin, *stopSpin;
	bool ignore;

	// data is actually a (DlgOpt *)
	friend gint cbDlgReloadButton(GtkWidget *widget, gpointer *data); 
	friend gint cbRenameInstance(GtkWidget *widget, gpointer *data); 
	friend void cbInitTime(GtkWidget *adj, DlgOpt *data);
	friend void cbStartTime(GtkWidget *adj, DlgOpt *data);
	friend void cbStopTime(GtkWidget *adj, DlgOpt *data);

	GtkSpinButton *addTimeSpinner(GtkBox *box, char *label, GtkSignalFunc callback);

public:
	DlgOpt(FXInstance *fxi);
	~DlgOpt();

	virtual void build();
	virtual const char *getName();

	virtual void show();	// show the dialog window

	void updateGui(); // reflect changes to the GUI 
	void updateTimeSpinners(); 
};

#endif
