/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * MouseController.h: mouse events managment for
 * Calodox DemoNiac by leto (leto@calodox.org), 7 2001
 */

#ifndef _MOUSECONTROLLER_H_
#define _MOUSECONTROLLER_H_

#include <gtk/gtk.h>

class MouseListener {
public:
	GtkToggleButton *toggle;
	
	virtual ~MouseListener();

	virtual void clicked(int button, double x, double y, int width, int height);
	virtual void dragged	(int button, double xStart, double yStart, 
				double xEnd, double yEnd,
				int width, int height);
	virtual void selected	(bool state);

	// diplay something to help user while changing the option.
	virtual void draw();
};

class MouseController {
private:
	GtkWidget *widget;
	bool buttonState[3];
	gdouble startPos[3][2];
	MouseListener *listener;
	guint motionId;

	friend gint cbMouse(GtkWidget *widget, GdkEvent *event, gpointer data); 

public:
	MouseController(GtkWidget *widget);

	void draw() {
		if (listener)
			listener->draw();
	}

	bool select(MouseListener *listener);
	void clear();
};

// general callback for selecting a listener
// use with a MouseListener as data
gint selectMouseListener(GtkWidget *widget, gpointer data);

#endif // _MOUSECONTROLLER_H_

