/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * 3D rotation option for demoniac
 * leto@calodox.org, 2001
 */

#ifndef _OPT3DROT_H_
#define _OPT3DROT_H_

#include "mousecontroller.h"
#include "genericoption.h"

class Opt3DRot : public GenericOption, public MouseListener {
private:
	Matrix4 mat;

public:
        Opt3DRot(FXInstance *fxi, char *optName, int flags, float value[4][4]);
	virtual ~Opt3DRot(); 
        float *fvalue;

        virtual void dragged    (int button, double xStart, double yStart, 
                                double xEnd, double yEnd,
                                int width, int height);
        virtual void draw(GtkBox *box);
        virtual void update();
	virtual void updateGui();
	virtual void computeValue(int time);
	virtual void save(Saver *s);
	virtual void load(Loader *l);
};

#endif 
