/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * Color option for demoniac
 * leto/calodox, 2001
 * leto@calodox.org
 */

#ifndef _OPTCOLOR_H_
#define _OPTCOLOR_H_

#include "genericoption.h"

class OptColor : public GenericOption {
private:
	// fvalues[0] is red, then green, blue, and
	// fvalues[3] is alpha. All values are between 0 and 1.
	float *fvalues;
	GtkWidget *dialog;

	friend gint cbOptColor(GtkWidget *widget, gpointer data);
	friend gint cbOptColorButton(GtkWidget *widget, gpointer data);
	friend gint cbOptColorClose(GtkWidget *widget, gpointer data);
public:
	OptColor(FXInstance *fxi, char *optName, int flags, float *values);

	virtual void draw(GtkBox *box);
        virtual void update();
	virtual void updateGui();
	virtual void computeValue(int time);
	virtual void save(Saver *s);
	virtual void load(Loader *l);
};

#endif
