/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * DrawBuffer option for demoniac
 * leto@calodox.org, 9.2001
 */

#ifndef _OPTDRAWBUFF_H_
#define _OPTDRAWBUFF_H_

#include <fx.h>
#include "saver.h"
#include "loader.h"
#include "genericoption.h"

class OptDrawBuffer : public GenericOption {
private:
	// pointer to effect buffer pointer
	DrawBuffer **buffer;	

	// Gtk stuff
	GtkWidget *button, *label;

	// call back
	static void cbClicked(GtkWidget *widget, OptDrawBuffer *obj);

public:
	OptDrawBuffer(FXInstance *fxi, char *optName, int flags, DrawBuffer **value);

	// called by DrawBufferList
	void changeDrawBuffer(DrawBuffer *buff);

        virtual void draw(GtkBox *box);
        virtual void update();
        virtual void updateGui();
        virtual void computeValue(int time);
        virtual void save(Saver *s);
        virtual void load(Loader *l);
};

#endif

