/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


/*
 * Float Option for demoniac
 * leto/calodox, 2001
 * leto@calodox.org
 */

#ifndef _OPTFLOAT_H_
#define _OPTFLOAT_H_

#include "genericoption.h"

class OptFloat : public GenericOption {
private:
        int lim;
        float min,max;
        GtkWidget *spin;

	friend gint cbOptFloat(GtkWidget *widget, gpointer data); 

public:
        OptFloat(FXInstance *fxi, char *optName, int flags, float *value,
	        float min, float max );

        float *fvalue;

	virtual void draw(GtkBox *box);
        virtual void update();
	virtual void updateGui();
	virtual void computeValue(int time);
	virtual void save(Saver *s);
	virtual void load(Loader *l);
};

#endif 
