/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * Error reporting system, for calodox demoniac.
 * leto@calodox.org, 9 2001.
 */

#ifndef _REPORT_H_
#define _REPORT_H_

#include <stdio.h>

#ifdef DEBUG
#define debug(s) printf("%s:%d: %s\n", __FILE__, __LINE__, s)
#else
#define debug(s) 
#endif

#define fatal(s) printf("%s:%d:FATAL ERROR: %s\n", __FILE__, __LINE__, s); exit(-1)

#ifndef NDEBUG
#define warning(s) printf("%s:%d:WARNING: %s\n", __FILE__, __LINE__, s)
#else
#define warning(s) 
#endif

#endif
