/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * Saver.h: tool to save objects in a file.
 * leto/calodox, 3.2001
 */

#ifndef _SAVER_H_
#define _SAVER_H_

#include <stdio.h>

class Saver {
    private:
	
	char *filename;

    public:

	Saver();
	~Saver();

	// returns true on success, false on error
	bool saveFile(char *filename);
	char *getFileName() { return filename; }

	void saveObjectBegin(char *name);
	void saveObjectEnd();

	void saveString(char *name, const char *str);
	void saveFloat(char *name, float f);
	void saveInt(char *name, int i);
	void saveFloatVect(char *name, int size, float *vect);
	void saveIntVect(char *name, int size, int *vect);

    private:

	FILE *out;	// output file
	int lev;	// indentation level

	void indent();	// write indentation
};

#endif

