/*
 * Calodox Demoniac
 * Copyright (C) 2001 Julien Pilet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * Key track dialog window for calodox DemoNiac
 * leto@calodox.org, 8.2001
 */

#ifndef _TRACKDLG_H_
#define _TRACKDLG_H_

#include "fxinstance.h"
#include "genericoption.h"
#include "dlg.h"
#include "track.h"

/*
 * this class do the work of creating and managing
 * the key track dialog, instead of GLMain.
 */
class TrackDlg : public Dlg{
private:
	GtkTree *root;
	GtkWidget *ruler;
	GtkAdjustment *timeRange;
	int pixSize;

	static void cbKeyPress(GtkTimeLine *timeline, GdkEventButton *event, GtkAdjustment *adj, gpointer data);
	static void cbKeyMoved(GtkAdjustment *adj, gpointer data);
	static void cbRemoveKey(GtkTimeLine *timeline, gpointer data);
	static void cbTimeChanged(GtkAdjustment *adj, TrackDlg *obj);
	static void cbZoom(GtkAdjustment *adj, TrackDlg *obj);
	static void cbZoomTimeLine(GtkAdjustment *adj, GtkTimeLine *timeLine);
	static void cbZoomIn(GtkWidget *widget, TrackDlg *obj);
	static void cbZoomOut(GtkWidget *widget, TrackDlg *obj);

public:
	TrackDlg();
	~TrackDlg();
	
	virtual void build();
	virtual const char *getName();

	void addFXInstance(FXInstance *fxi);
	void removeFXInstance(FXInstance *fxi);

	void addOption(GenericOption *opt);
	void removeOption(GenericOption *opt);

	static void addKey(Track *track, Key *key);
	static void removeKey(Track *track, Key *key);
	static void moveKey(Key *key);

};

#endif // _TRACKDLG_H_
